@echo off
:: Ot@C̃t@CpX
set LOGFILE_PATH=
:: L-Platformz̊҂̃gC
set DEPLOY_WAIT_COUNT=10
:: L-Platformz̊҂(b)
set DEPLOY_WAIT_TIME=60

::
:: Main
::
:: Parameter
::  %1 L-Platform ID
::  %2 Tenant name
::  %3 User ID
::  %4 Dual-role administrator/Infrastructure administrator ID
::  %5 Dual-role administrator/Infrastructure administrator password
:: Return
::  0 Succeeded
::  1 Failed
::
call :METHOD_OUTPUT_LOG "[INFO  ] The intermediate_script has started. [L-Platform ID:%1][Tenant name:%2][User ID:%3]"
set ADMIN_USERID=%~4
set ADMIN_PWD=%~5

:: 1. L-Platformz̊mF
call :METHOD_WAIT_DEPLOY %1 %2
if not %errorlevel% == 0 (
  exit /b 1
)

:: 2. L-PlatformуT[o̎擾
call :METHOD_GET_LPLATFORMINFO %1 %2
if not %errorlevel% == 0 (
  exit /b 1
)

:: 3. Wu˗XNvg̎s
call :METHOD_CONFIGURATION_CHANGE %3 %TEMPLATE_ID% %SERVER_COUNT% %IMAGE_IDS% %IPADDRESSES% %1
if not %errorlevel% == 0 (
  exit /b 1
)
call :METHOD_OUTPUT_LOG "[INFO  ] The intermediate_script has completed. [L-Platform ID:%1][Tenant name:%2][User ID:%3]"
exit /b 0

::
:: Ot@CɃbZ[Wo͂܂B
::
:: Parameter
::  %1 Message
::
:METHOD_OUTPUT_LOG
setlocal
echo %DATE% %TIME:~0,8% %~1 >>"%LOGFILE_PATH%"
endlocal
exit /b 0

::
:: L-Platform̔z҂܂B
:: Parameter
::  %1 L-Platform ID
::  %2 Tenant name
:: Return
::  0 Succeeded
::  1 Failed
::
:METHOD_WAIT_DEPLOY
setlocal enabledelayedexpansion
timeout /t %DEPLOY_WAIT_TIME% > nul 2>&1
for /l %%i in (1,1,%DEPLOY_WAIT_COUNT%) do (
  for /f "usebackq" %%j in (`"%RCXCFMG_HOME%\bin\GetLPlatformStatus.bat" -version 2.0 -locale ja -userId %ADMIN_USERID% -password %ADMIN_PWD% -orgId %2 -lplatformId %1`) do (
    echo "%%j" | findstr /l "<lplatformStatus>NORMAL</lplatformStatus>" > nul 2>&1
    if !errorlevel! == 0 (
      endlocal
      exit /b 0
    )
  )
  timeout /t %DEPLOY_WAIT_TIME% > nul 2>&1
)

call :METHOD_OUTPUT_LOG "[ERROR ] Failed to wait the L-Platform deployment. [L-Platform ID:%1][Tenant name:%2]"
endlocal
exit /b 1

::
:: L-Platform̏ڍ׏擾܂B
::
:: Parameter
::  %1 L-Platform ID
::  %2 Tenant name
:: Return
::  0 Succeeded
::  1 Failed
:: Referred value
::  %TEMPLATE_ID%  Template ID
::  %SERVER_COUNT% Number of servers
::  %IMAGE_IDS%    Image IDs
::  %IPADDRESSES%  IP addresses
::
:METHOD_GET_LPLATFORMINFO
setlocal enabledelayedexpansion
set XMLFILE_NAME=%1
cd "%~dp0"
call "%RCXCFMG_HOME%\bin\GetLPlatformConfiguration.bat" -version 2.0 -locale ja -userId %ADMIN_USERID% -password %ADMIN_PWD% -orgId %2 -lplatformId %1 > %XMLFILE_NAME%
if not %errorlevel% == 0 (
  call :METHOD_OUTPUT_LOG "[ERROR ] Failed to execute the GetLPlatformConfiguration. [L-Platform ID:%1][Tenant name:%2]"
  endlocal
)
set QUERY=/*[local-name^^(^^)^^=\"GetLPlatformConfigurationResponse\"]/*[local-name^^(^^)^^=\"lplatform\"]/*[local-name^^(^^)^^=\"lservers\"]/*[local-name^^(^^)^^=\"lserver\"]
for /f "usebackq" %%i in (`powershell -Command $XmlDoc^=[System.Xml.XmlDocument]^(Get-Content '%XMLFILE_NAME%'^)^;Write-Output $XmlDoc.SelectNodes^('%QUERY%'^).Count 2^>nul`) do (
  set SERVER_COUNT=%%i
)

if not defined SERVER_COUNT (
  call :METHOD_OUTPUT_LOG "[ERROR ] Failed to count the number of servers. [L-Platform ID:%1][Tenant name:%2]"
  endlocal
  exit /b 1
)
set QUERY=/*[local-name^^(^^)^^=\"GetLPlatformConfigurationResponse\"]/*[local-name^^(^^)^^=\"lplatform\"]/*[local-name^^(^^)^^=\"baseDescriptor\"]/text^^(^^)
for /f "usebackq" %%i in (`powershell -Command $XmlDoc^=[System.Xml.XmlDocument]^(Get-Content '%XMLFILE_NAME%'^)^;Write-Output $XmlDoc.SelectSingleNode^('%QUERY%'^).Get_Value^(^) 2^>nul`) do (
  set TEMPLATE_ID=%%i
)

if not defined TEMPLATE_ID (
  call :METHOD_OUTPUT_LOG "[ERROR ] Failed to get Template ID. [L-Platform ID:%1][Tenant name:%2]"
  endlocal
  exit /b 1
)

for /l %%i in (1,1,%SERVER_COUNT%) do (
  set IMAGE_ID=
  set IPADDRESS=

  set QUERY=/*[local-name^^^(^^^)^^^=\"GetLPlatformConfigurationResponse\"]/*[local-name^^^(^^^)^^^=\"lplatform\"]/*[local-name^^^(^^^)^^^=\"lservers\"]/*[local-name^^^(^^^)^^^=\"lserver\"][%%i]/*[local-name^^^(^^^)^^^=\"diskimageId\"]/text^^^(^^^)
  for /f "usebackq" %%j in (`powershell -Command $XmlDoc^=[System.Xml.XmlDocument]^(Get-Content '%XMLFILE_NAME%'^)^;Write-Output $XmlDoc.SelectSingleNode^('!QUERY!'^).Get_Value^(^) 2^>nul`) do (
    set IMAGE_ID=%%j
  )
  set QUERY=/*[local-name^^^(^^^)^^^=\"GetLPlatformConfigurationResponse\"]/*[local-name^^^(^^^)^^^=\"lplatform\"]/*[local-name^^^(^^^)^^^=\"lservers\"]/*[local-name^^^(^^^)^^^=\"lserver\"][%%i]/*[local-name^^^(^^^)^^^=\"nics\"]/*[local-name^^^(^^^)^^^=\"nic\"][*[local-name^^^(^^^)^^^=\"management\"]^^=\"1\"]/*[local-name^^^(^^^)^^^=\"privateIp\"]/text^^^(^^^)
  for /f "usebackq" %%j in (`powershell -Command $XmlDoc^=[System.Xml.XmlDocument]^(Get-Content '%XMLFILE_NAME%'^)^;Write-Output $XmlDoc.SelectSingleNode^('!QUERY!'^).Get_Value^(^) 2^>nul`) do (
    set IPADDRESS=%%j
  )

  if "!IMAGE_ID!" == "" (
    call :METHOD_OUTPUT_LOG "[ERROR ] Failed to get Image ID. [L-Platform ID:%1][Tenant name:%2]"
    endlocal
    exit /b 1
  )
  if "!IPADDRESS!" == "" (
    call :METHOD_OUTPUT_LOG "[ERROR ] Failed to get IP address. [L-Platform ID:%1][Tenant name:%2]"
    endlocal
    exit /b 1
  )

  set IMAGE_IDS=!IMAGE_IDS!,!IMAGE_ID!
  set IPADDRESSES=!IPADDRESSES!,!IPADDRESS!
)
del %XMLFILE_NAME%
endlocal & set TEMPLATE_ID="%TEMPLATE_ID%" & set SERVER_COUNT="%SERVER_COUNT%" & set IPADDRESSES="%IPADDRESSES%" & set IMAGE_IDS="%IMAGE_IDS%"
exit /b 0

::
:: OSƃ~hEFA̐ݒs܂B
::
:: Parameter
::  %1 User ID
::  %2 Template ID
::  %3 Number of servers
::  %4 Image IDs
::  %5 IP addresses
::  %6 L-Platform ID
:: Return
::  0 Succeeded
::  1 Failed
::
:METHOD_CONFIGURATION_CHANGE
setlocal
for /l %%i in (1,1,%~3) do (
  call :SUB_METHOD_CONFIGURATION_CHANGE %%i %~1 %~2 "%~4" "%~5" "%~6"
)
endlocal
exit /b 0

:: Parameter
::  %1 Order of servers
::  %2 User ID
::  %3 Template ID
::  %4 Image IDs
::  %5 IP addresses
::  %6 L-Platform ID
:SUB_METHOD_CONFIGURATION_CHANGE
setlocal
for /f "tokens=%1 delims=," %%i in ("%~4") do (
  set IMAGE_ID=%%i
)
for /f "tokens=%1 delims=," %%i in ("%~5") do (
  set IPADDRESS=%%i
)

set SCRIPTFILE_PATH=%~dp0%3\%IMAGE_ID%.bat
if exist "%SCRIPTFILE_PATH%" (
  powershell -Command Start-Process -FilePath '"%SCRIPTFILE_PATH%"' -ArgumentList '%~2','%IPADDRESS%','%~6'
  call :METHOD_OUTPUT_LOG "[INFO  ] The %IMAGE_ID%.bat has completed. [IP address:%IPADDRESS%][Template ID:%3][Image ID:%IMAGE_ID%][L-Platform ID:%~6]"
) else (
  call :METHOD_OUTPUT_LOG "[INFO  ] The %IMAGE_ID%.bat was not performed. [IP address:%IPADDRESS%][Template ID:%3][Image ID:%IMAGE_ID%][L-Platform ID:%~6]"
)
endlocal
exit /b 0